package UE01_030924_Wiederholung;

public class Kreditkonto extends Konto {
    String name = "undefined";

    public Kreditkonto(String name, double zinssatz, double betrag) {
        super((betrag < 0 ? betrag : betrag * -1), zinssatz, "Kreditkonto");
        if (name != null) this.name = name;
    }

    public double einzahlung(double betrag) {
        if (betrag < 0) return 0;
        double overflow = this.kontostand;
        this.kontostand += betrag;
        if (this.kontostand > 0) {
            this.kontostand = 0;
            this.buchungsvorgaenge.add("Einzahlung: " + (-overflow));
            return Math.abs(overflow);
        }
        this.buchungsvorgaenge.add("Einzahlung: " + betrag);
        return betrag;
    }

    @Override
    public String toString() {
        return kontonummer(this.kontonummer) + " - " + this.kontoTyp + " von " + this.name + ": Zinssatz: " + this.zinssatz + "%, Kontostand: " + this.kontostand;
    }
}